﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace WindowsApplication1
{
    public partial class Form1 : Form
    {
        byte[] sendData = new byte[1];
        int gxX, gyX, gxY, gyY, gxZ, gyZ, count;
        int adX, adY, adZ;
        string path;

        public Form1()
        {
            InitializeComponent();
        }
        //　スタートボタンによりBackGroundWorkerを起動する
        private void button1_Click(object sender, EventArgs e)
        {
            this.backgroundWorker1.RunWorkerAsync();
        }
        //　ストップボタンによりCancel処理を行う
        private void button2_Click(object sender, EventArgs e)
        {
            this.backgroundWorker1.CancelAsync();
        }
        //　シリアルポートをオープンしコマンド送信後、データ受信、グラフ表示、ファイル記録を行う
        //　シリアルポートの通信条件は[デザイン]のserialport1のプロパティで行っている
        //　ピクチャーボックスは左上が（０，０）なので、左下が原点になるようにグラフを表示する
        private void backgroundWorker1_DoWork(object sender, DoWorkEventArgs e)
        {
            //シリアルポートの有無などのエラー処理は省略
            serialPort1.Close();
            serialPort1.Open();
            //dsPICにデータ送信コマンドである0x01を送信する
            sendData[0] = 1;
            serialPort1.Write(sendData, 0, 1);
            //初期値とグラフ表示エリアの設定を行う
            gxX = 0; gyX = 0; gxY = 0; gyY = 0; gxZ = 0; gyZ = 0; count = 0;
            Graphics g = pictureBox1.CreateGraphics();
            g.Clear(Color.White);
            //CSVファイルの保存先を設定し、x、y、zの文字を書き込んでおく
            path = textBox1.Text;
            System.IO.StreamWriter textFile;
            textFile = System.IO.File.CreateText(path);
            textFile.Write('X'); textFile.Write(',');
            textFile.Write('Y'); textFile.Write(',');
            textFile.Write('Z'); textFile.Write(Environment.NewLine);
            //STOPボタンが押されるまで処理を繰り返す
            //（注）EXCELで読込めるCSVは３２０００行までであるがこの判定は加えていない
            while (backgroundWorker1.CancellationPending == false)
            {
                if (serialPort1.ReadByte() == 255)
                {
                    if (serialPort1.ReadByte() == 255)
                    {
                        //ｘ軸のデータを２バイト受信し、グラフ表示とCSV保存を行う
                        //１２ビットのデータは最大４０９５なのでグラフ表示するときは１／８にする
                        adX = serialPort1.ReadByte() + serialPort1.ReadByte() * 256;
                        if ((adX > 4095) | (adX < 0)) { adX = gyX; }
                        g.DrawLine(Pens.Blue, gxX, 511 - gyX / 8, gxX + 1, 511 - adX / 8);
                        gxX++; gyX = adX;
                        textFile.Write(Convert.ToString(adX));
                        textFile.Write(',');
                        //ｙ軸のデータを２バイト受信し、グラフ表示とCSV保存を行う
                        adY = serialPort1.ReadByte() + serialPort1.ReadByte() * 256;
                        if ((adY > 4095) | (adY < 0)) { adY = gyY; }
                        g.DrawLine(Pens.Green, gxY, 511 - gyY / 8, gxY + 1, 511 - adY / 8);
                        gxY++; gyY = adY;
                        textFile.Write(Convert.ToString(adY));
                        textFile.Write(',');
                        //ｚ軸のデータを２バイト受信し、グラフ表示とCSV保存を行う
                        adZ = serialPort1.ReadByte() + serialPort1.ReadByte() * 256;
                        if ((adZ > 4095) | (adZ < 0)) { adZ = gyZ; }
                        g.DrawLine(Pens.Magenta, gxZ, 511 - gyZ / 8, gxZ + 1, 511 - adZ / 8);
                        gxZ++; gyZ = adZ;
                        textFile.Write(Convert.ToString(adZ));
                        textFile.Write(Environment.NewLine);
                        //グラフ表示エリアが終わる１０００点目をグラフ表示した後、グラフエリアをクリア
                        count++;
                        if (count >= 1000)
                        { gxX = 0; gxY = 0; gxZ = 0; count = 0; g.Clear(Color.White); }
                    }
                }
            }
            textFile.Close(); e.Cancel = true;
        }
        //　キャンセル処理で停止コマンドを送信し、シリアルポートをクローズする
        private void backgroundWorker1_RunWorkerCompleted(object sender, RunWorkerCompletedEventArgs e)
        {
            sendData[0] = 0;
            serialPort1.Write(sendData, 0, 1);
            serialPort1.Close();
        }
    }
}