//**************************************************************
// AHIRUchan program V1.0 2007.09.03
// AN0 => Z  AN1 => Y  AN2 => X
// Library: libp30F2012-coff.a  Linker: p30f2012.gld
//**************************************************************
#include <p30f2012.h>
#include <adc12.h>
#include <uart.h>
#include <timer.h>
// configuration
_FWDT(WDT_OFF);_FGS(CODE_PROT_OFF);_FOSC(CSW_FSCM_OFF & FRC_PLL4);
_FBORPOR(PBOR_OFF & PWRT_64 & MCLR_EN);
#define Fcy 7370000
#define BaudRate 19200
// A/D control register
unsigned int _ADCON1, _ADCON2, _ADCON3, _ADCHS0, _ADCHS1, _ADCHS2, _ADPCFG, _ADCSSL;
// UART control register
unsigned int _U1BRG, _U1MODE, _U1STA;
// variable
unsigned int Adata;
unsigned char CNT, CMD, Udata, Ldata;
// timer3 int
void __attribute__((__interrupt__, __shadow__, no_auto_psv)) _AltT3Interrupt(void)
{    IFS0bits.T3IF=0;
     if( CMD != 0) {
     switch( CNT )
     {      case 0: //0xFFFF
            {     WriteUART1(0xFF); while(BusyADC12()); Adata=ReadADC12(0); //dummy read
                  CNT++; WriteUART1(0xFF); break; }
            case 1: //AN2(X)
            {     while(BusyADC12()); Adata=ReadADC12(0);
                  Ldata = (unsigned char)(0x00FF & Adata); WriteUART1(Ldata);
                  SetChanADC12(_ADCHS1); CNT++; //next channel
                  Udata = (unsigned char)(0x00FF & (Adata >> 8)); WriteUART1(Udata);
                  break; }
            case 2: //AN1(Y)
            {     while(BusyADC12()); Adata=ReadADC12(0);
                  Ldata = (unsigned char)(0x00FF & Adata); WriteUART1(Ldata);
                  SetChanADC12(_ADCHS0); CNT++; //next channel
                  Udata = (unsigned char)(0x00FF & (Adata >> 8)); WriteUART1(Udata);
                  break; }
            case 3: //AN0(Z)
            {     while(BusyADC12()); Adata=ReadADC12(0);
                  Ldata = (unsigned char)(0x00FF & Adata); WriteUART1(Ldata);
                  SetChanADC12(_ADCHS2); CNT=0; //next channel
                  Udata = (unsigned char)(0x00FF & (Adata >> 8)); WriteUART1(Udata);
                  break; }
            default: CNT=0; break; } }
}
//RX int
void __attribute__((__interrupt__, __shadow__, no_auto_psv)) _AltU1RXInterrupt(void)
{    IFS0bits.U1RXIF=0; CMD = ReadUART1();
     if(CMD == 0) {PORTCbits.RC13=0;} else {PORTCbits.RC13=1;}
}
// Main routine
int main(void)
{     TRISB=0x03FFF; TRISC=0xC000; TRISD=0x0300; TRISF=0x0074; PORTCbits.RC13=0;
      INTCON2bits.ALTIVT=1;
// set UART
      CloseUART1(); CMD = 0;
      ConfigIntUART1(UART_RX_INT_EN & UART_RX_INT_PR3 & UART_TX_INT_DIS);
      _U1BRG=  ((Fcy/BaudRate)/16);
      _U1MODE= UART_EN & UART_IDLE_CON & UART_RX_TX & UART_DIS_WAKE & UART_DIS_LOOPBACK &
               UART_EN_ABAUD & UART_NO_PAR_8BIT & UART_1STOPBIT;
      _U1STA=  UART_INT_TX_BUF_EMPTY & UART_TX_PIN_NORMAL &
               UART_TX_ENABLE & UART_INT_RX_CHAR & UART_ADR_DETECT_DIS & UART_RX_OVERRUN_CLEAR;
      OpenUART1(_U1MODE, _U1STA, _U1BRG);
//set ADC
      _ADCON1= ADC_MODULE_ON & ADC_IDLE_CONTINUE & ADC_FORMAT_INTG & ADC_CLK_TMR &  //Timer3 INT
               ADC_AUTO_SAMPLING_ON & ADC_SAMP_OFF;
      _ADCON2= ADC_VREF_AVDD_AVSS & ADC_SCAN_OFF &
               ADC_SAMPLES_PER_INT_1 & ADC_ALT_BUF_OFF &  ADC_ALT_INPUT_OFF;
      _ADCON3= ADC_SAMPLE_TIME_1 & ADC_CONV_CLK_SYSTEM & ADC_CONV_CLK_5Tcy;
      _ADPCFG= ENABLE_AN0_ANA & ENABLE_AN1_ANA & ENABLE_AN2_ANA;
      _ADCSSL= SCAN_NONE;
      _ADCHS0= ADC_CH0_POS_SAMPLEA_AN0 & ADC_CH0_NEG_SAMPLEA_NVREF;
      _ADCHS1= ADC_CH0_POS_SAMPLEA_AN1 & ADC_CH0_NEG_SAMPLEA_NVREF;
      _ADCHS2= ADC_CH0_POS_SAMPLEA_AN2 & ADC_CH0_NEG_SAMPLEA_NVREF;
      ConfigIntADC12(ADC_INT_DISABLE); SetChanADC12(_ADCHS2); //AN2(X)
      CNT=0; OpenADC12(_ADCON1, _ADCON2, _ADCON3, _ADPCFG, _ADCSSL);
//set TIMER3  0.0025sec/(1/7.37MHz)
      OpenTimer3(T3_ON & T3_GATE_OFF & T3_PS_1_1 & T3_SOURCE_INT, 18425-1);
      ConfigIntTimer3(T3_INT_PRIOR_5 & T3_INT_ON);
// enable interrupt
      DISICNT = 0x0000;
// main loop
      while(1) { }
}
